#pragma once

#include <GL/glew.h>
#include <glm/glm.hpp>

struct settings;

struct shader
{
  bool double_precision;
  // program
  GLuint program;
  // uniform location
  GLint centering;
  GLint center;
  GLint radius;
  GLint aspect;
  GLint mandelbrot;
  GLint count;
  GLint inflection;
  GLint er;
  GLint iterations;
  GLint samples;
  GLint colours;
};

struct shader compile_shader(bool double_precision);

void update_shader(const struct shader &d, const struct settings &s, dvec2 aspect);
